
#include "fparser.hh"
#include<simplecpp>
#include <string.h>
#include<cmath>

struct lineParameters {

float m, c ;

};

float mean(float X[],int n)
{
    int i;

    float sum=0.0;

    for(i=0;i<n;i++)

        {
        sum= sum+ X[i];
        }

return(sum/n);

}

float variance(float X[], int n)
{
    int i;

    float sum =0.0,expx2,var ;

    for(i=0;i<n;i++)
    {
    sum=sum+ X[i]*X[i];
    }

    expx2 = sum/n ;

    var = expx2 - (mean(X,n)*mean(X,n));

return(var);
}
float covariance(float X[], float Y[], int n)
{
    float sum =0.0,expxy,cov;

    int i;

    for(i=0;i<n;i++)
        {
        sum= sum + X[i]*Y[i];
        }

    expxy=sum/n;

    cov = expxy- (mean(X,n)*mean(Y,n));

return(cov);

}

lineParameters regression(float X[],float Y[],int n)
{
    lineParameters P;

    float b = covariance(X,Y,n)/variance(Y,n);

    float d = mean(X,n) - mean(Y,n) * b ;

    P.m = b;

    P.c = d;

return(P);
}
int statFeature()
{
    int input, n,i, bullet,bullet1,bull3;

    cout << "";

    float * X = new float [n];

    float * Y= new float [n];

    lineParameters linX, linY;

    float coeff = 0.0;

cout<<"____________________________________________________"<<endl;
cout<<"Welcome to Statistical Functions :"<<endl;
cout<<"____________________________________________________"<<endl;

cout<<"You have two samples of same size"<<endl;

cout<<"Enter the sample size :";

cin>> n;

cout<<endl;

cout<<"Enter data : ";

cout<< "X = "<<endl;

for(i=0; i<n ; i++)
    {

    cin>> X[i];

    }

cout<<endl;

cout<< "Y = "<<endl;

for(i=0;i<n ;i++)
{
cin>>Y[i];
}

cout<<"Enter the following features :"<<endl<<"1. Sample mean"<<endl;
cout<<"2. Sample Variance"<<endl<<"3. Line of Regression "<<endl<<"4. Coefficient of Correlation"<<endl;
cout<<"Press -1 to exit : ";

while(true)
    {
        cin>>input;

        switch(input)
        {

            case 1:
            cout<<"Please enter:"<<endl<<"1. Mean X"<<endl<<"2. Mean Y"<<endl<<"0. To go back"<<endl;

            do{
                cin>>bullet;

                if(bullet==1)
                {
                cout<< "Mean X = "<<mean(X,n)<<endl;
                }

                else if(bullet==2)
                {
                cout<< "Mean Y = "<<mean(Y,n)<<endl;
                }

                else if((bullet !=1)&&(bullet !=2) && (bullet!=0))
                {
                cout<<"Wrong input! Please input again, guess you got that wrong!"<<endl;
                continue;
                }

            }while(bullet!=0);

            if(bullet==0)
            {
            cout<<"Enter the following features :"<<endl<<"1. Sample mean"<<endl;
            cout<<"2. Sample Variance"<<endl<<"3. Line of Regression "<<endl<<"4. Coefficient of Correlation"<<endl;
            cout<<"Press -1 to exit : ";
            }

            break;

            case 2 :

            cout<<"Please enter :"<<endl<<"1. Sample Variance X"<<endl<<"2. Sample Variance Y"<<endl<<"0. To go back"<<endl;

            do{

                cin>>bullet1;

                if(bullet1==1)
                {
                cout<<"Sample Variance X = "<<variance(X,n)<<endl;
                }

                else if(bullet1==2)
                {
                cout<<"Sample Variance Y = "<<variance(Y,n)<<endl;
                }

                else if(bullet1 !=1&&bullet1 !=2&&bullet1 !=0)
                {
                cout<<"Wrong input! Please input again, guess you got that wrong!"<<endl;
                continue;
                }

            }while(bullet1 !=0);

            if(bullet1==0)
            {
            cout<<"Enter the following features :"<<endl<<"1. Sample mean"<<endl;
            cout<<"2. Sample Variance"<<endl<<"3. Line of Regression "<<endl<<"4. Coefficient of Correlation"<<endl;
            cout<<"Press -1 to exit : ";

            }

            break;
            case 3 :
            cout<<"1. Line of regression of X on Y "<<endl<<"2. Line of regression of Y on X"<<endl<<"0. To go back"<<endl;
            do{
                cin>>bull3;

                if(bull3 == 1)
                {
                linX = regression(X,Y,n);
                cout<< "x = "<<linX.m<<"*y + ("<<linX.c<<")"<<endl;

                }

                else if(bull3 == 2)
                {
                linY = regression(Y,X,n);
                cout<<"y = "<<linY.m<<"*x + ("<<linY.c<<")"<<endl;
                }

                else if (bull3 !=1&&bull3 !=2&&bull3 !=0)
                {
                cout<<"Wrong input! Please input again, guess you got that wrong!"<<endl;
                continue;
                }

            }while(bull3 !=0);

            if(bull3==0)
            {
            cout<<"Enter the following features :"<<endl<<"1. Sample mean"<<endl;
            cout<<"2. Sample Variance"<<endl<<"3. Line of Regression "<<endl<<"4. Coefficient of Correlation"<<endl;
            cout<<"Press -1 to exit : ";

            }
            break;

            case 4 :
            coeff = covariance(X,Y,n)/sqrt(variance(X,n)*variance(Y,n));
            cout<<"The Karl Pearsons Coefficient of Correlation b/w the two samples is = "<<coeff<<endl<<"which implies: "<<endl;
            if(coeff < 0)
            {
            cout<<"The two variables are negatively correlated. "<<endl;
            }

            else if(coeff>0)
            {
            cout<<"The two variables are positively correlated. "<<endl;
            }

            else if(coeff==0)
            {
            cout<<"There is no linear correlation between the two variables, we should try curvilinear regression!"<<endl;
            }

            cout<<"Enter the following features :"<<endl<<"1. Sample mean"<<endl;
            cout<<"2. Sample Variance"<<endl<<"3. Line of Regression "<<endl<<"4. Coefficient of Correlation"<<endl;
            cout<<"Press -1 to exit : ";
            break;

            case -1:
            cout<<"--------------Thank You for Trying------------------------"<<endl;
            return -1 ;

            default:
            cout<<"Wrong input, guess you got it wrong!"<<endl;
            continue;

    }
 }

return 0;
}

double gamma(float &n)
{
    if(n==1)return 1;

    if(n==1/2)return sqrt(3.1415926535897932);

    else

return n*gamma(n-1);

}
int main()
{
    double vx,vy,p,q,x0,df,c,xp,h=0.00001,unit=50;

    int newunit,error;

    float a,b,mu,mu1,sig,a1,b1;

    double * vx1,* vy1,* zp,* zq;

    char ch,ch1;

    int FLAG=0;

    string function,strFunction;

    FunctionParser fparser;

    fparser.AddConstant("pi", 3.1415926535897932);

     cout<<"*********************************************************************"<<endl;
     cout<<"Welcome to 2D GRAPH PLOTTER FOR STATISTICAL AND MATHEMATICAL PURPOSES"<<endl;
     cout<<"*********************************************************************"<<endl;
     cout<<"To Get Standard Continuous Distribution Curve Enter Y "<<endl;
     cout<<"--------------------------------------------------------------------"<<endl;
     cout<<"And for Other Curves please Enter N"<<endl;
     cout<<"--------------------------------------------------------------------"<<endl;
     cout<<"To Access our Statistical feature Enter S"<<endl;
     cout<<"--------------------------------------------------------------------"<<endl;
     cout<<"(Press x to exit)"<<endl;

    do{
      cin>>ch;
      if(ch == 'x')
      {
      return 0;
      }
      switch(ch)

      {
      case 'Y':
              cout<<"To get Normal Distribution Curve press N"<<endl<<"To get Exponential Distribution "
              <<"Curve press E"<<endl
              <<"To get uniform Distribution Curve press U"<<endl<<"To get chi square Distribution Curve press C"<<endl;

              cin>>ch1;

              switch(ch1)

                  {

                  case 'N':

                  {
                  cout<<"enter mean"<<endl;

                  cin>>mu;

                   cout<<"enter standard deviation"<<endl;

                  cin>>sig;

                  for(;sig<0;)
                  {
                  cout<<"invalid input.plese enter positive S.D"<<endl;

                   cin>>sig;
                   }
                 strFunction="(1/(sqrt(2*3.14)*";

                 strFunction+=std::to_string(sig);//function.append(sig);

                 strFunction+="))*exp((-0.5)*((x-";

                 strFunction+=std::to_string(mu);

                 strFunction+=")/";

                 strFunction+=std::to_string(sig)  ;

                 strFunction+=")^2)";

                function=strFunction;

                fparser.Parse(function, "x");

                   break;
                  }
                  case 'E':
                  {
                  cout<<"enter rate parameter"<<endl;

                  cin>>mu;

                   for(;mu<0;)

                  {
                  cout<<"invalid input.plese enter positive Rate parameter"<<endl;

                   cin>>mu;
                   }
                   strFunction+=std::to_string(mu);

                   strFunction+="*exp(-";

                   strFunction+=std::to_string(mu);

                   strFunction+="*x)";

                   function=strFunction;

                   fparser.Parse(function, "x");

                   break;
                  }
                  case 'U':
                  {
                   a1=0,b1=1;

                  strFunction+="1/(";

                  strFunction+=std::to_string(b1);

                  strFunction+="-";

                  strFunction+=std::to_string(a1);

                  strFunction+=")";

                  function=strFunction;

                  fparser.Parse(function, "x");

                  break;
                  }
                  case 'C':
                  {

                  cout<<"Enter degree of freedom"<<endl;

                  cin>>mu;

                  for(;mu<0;){
                                cout<<"invalid input.please enter positive Degree of Freedom"<<endl;

                                cin>>mu;
                            }
                   mu1=mu/2;

                   strFunction+="(x^(";

                   strFunction+=std::to_string(mu1);

                   strFunction+="-1)*exp(-(x/2)))/(2^(";

                   strFunction+=std::to_string(mu1);

                   strFunction+=")*";

                     cout<<function;

                   strFunction+=std::to_string(gamma(mu1));

                     cout<<function;

                   strFunction+=")";

                   function=strFunction;

                  fparser.Parse(function, "x");

                  cout<<function;

                  break;
                  }

                  default:

                  cout<<"You have pressed wrong key "<<endl;

                  break;
                  }

                  break;

      case 'N':
              while(true)

                    {
                        cout << "f(x) = ";

                        getline(cin, function);

                        if(cin.fail())

                            return 0;

                        int res = fparser.Parse(function, "x");

                        if(res < 0)

                            break;

                        cout <<string(res+7, ' ') << "^\n"

                                  << fparser.ErrorMsg() << "\n\n";
                    }

                    break;

       case 'S':

            statFeature();
            break;

       default:
             cout<<"Invalid input"<<endl;
             break;

      }

     if(ch=='Y'||ch=='N')
      {

            cout<<"Please Specify your desired Interval:"<<endl;

            cin>>a>>b;

            if(a<-12||b>12)

                {
                    newunit=800/(b-a);

                    while(1200%newunit!=0&&800%newunit!=0)

                        newunit--;

                    unit=newunit;
                }
            if(ch1=='U')

            {
            a1=a;
            b1=b;
            }

            cout<<"Do you want to see the tangent at any point between a&b:"<<endl
            <<"if yes press 1 , if no press 0"<<endl;

            cin>>FLAG;

            if(FLAG==1)
            {
                cout<<"Enter the point:"<<endl;

                cin>>x0;

                xp=x0+h;

                zp=&xp;zq=&x0;

                df=(fparser.Eval(zp)-fparser.Eval(zq))/h;

                error=fparser.EvalError();

                if(error!=0)
                   {
                      cout<<"The function is not differentiable at"<<x0;
                   }
             }

    initCanvas("graph",1200,800);

    p=1200;

    q=800;

    Line line1(0,q/2,p,q/2);

    Line line2(p/2,0,p/2,q);

    for(int i=0;i<=q;i=i+unit)
    {
        Text t1(p/2,i,"-");

        t1.imprint();

        if(i!=q/2)

            {
                Text t2(p/2+20,i,(q/2-i)/unit);

                t2.imprint();
            }
    }

    for(int i=0;i<=p;i=i+unit)
    {
            Text t3(i,q/2,"|");t3.imprint();

            if(i!=p/2)

                {
                    Text t4(i,q/2+20,(i-p/2)/unit);
                    t4.imprint();
                }
    }

    for(float i=a;i<=b;i=i+0.001)

    {
        vx=i;

        vy=i+0.001;

        vx1=&vx;

        vy1=&vy;

        if(ch1=='E'||ch1=='C')

        {
        if(vy<0)
                {

                    Line line(vx,q/2,vy,q/2);

                    line.setColor(COLOR("blue"));

                    line.imprint();
                }
        else
            {
                    Line line((p/2+(unit*vx)),(q/2-(unit*(fparser.Eval(vx1)))),(p/2+(unit*vy)),(q/2-(unit*(fparser.Eval(vy1)))));

                    line.setColor(COLOR("blue"));

                    line.imprint();
            }
        }
        else
            {
                 Line line((p/2+(unit*vx)),(q/2-(unit*(fparser.Eval(vx1)))),(p/2+(unit*vy)),(q/2-(unit*(fparser.Eval(vy1)))));
                 line.setColor(COLOR("blue"));


                    if(((unit*fparser.Eval(vx1))<=650)&&((unit*fparser.Eval(vx1))>=-650))
                         {
                                 line.imprint();
                         }
             }
    }

    if(FLAG==1)

        {

        c=(fparser.Eval(&x0)-(df*x0));

        Line line3 ((p/2+(unit*(x0+1))),(q/2-(unit*(c+((x0+1)*df)))),(p/2+(unit*(x0-1))),(q/2-(unit*(c+((x0-1)*df)))));

        line3.setColor(COLOR("red"));

        line3.imprint();


        }

    wait(20);

    }
     cout<<"To Get Standard Continuous Distribution Curve Enter Y "<<endl;
     cout<<"--------------------------------------------------------------------"<<endl;
     cout<<"And for Other Curves please Enter N"<<endl;
     cout<<"--------------------------------------------------------------------"<<endl;
     cout<<"To Access our Statistical feature Enter S"<<endl;
     cout<<"--------------------------------------------------------------------"<<endl;
     cout<<"(Press x to exit)"<<endl;

}while(ch!='x');

return 0;
}




